(*

  Mit diesem Programm kann getestet werden, ob ein Port
  offen ist oder nicht.

  Es wurde mit Indy 8.0 erzeugt.

  Ulf Schaper

*)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient;

type
  TForm1 = class(TForm)
    Button1: TButton;
    SpinEdit1: TSpinEdit;
    Memo1: TMemo;
    TCPClient: TIdTCPClient;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    procedure TCPClientConnected(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

 // Wird eingebunden, um den Typ der Exception
 // abfragen zu knnen
 uses IdException;

{$R *.DFM}

procedure TForm1.TCPClientConnected(Sender: TObject);
var Daten:string;
begin
  // Eine Verbindung ist aufgebaut worden.
  Memo1.Lines.Add('Verbunden');

  // Jetzt wird berprft, ob der Server Daten sendet.
  Daten := TCPClient.ReadLn('',5000); // Timeout = 5 secs
  if length(Daten) = 0 then
    Memo1.Lines.Add('Server sendet keine Daten!')
   else
    begin 
     Memo1.Lines.Add('Server sendet:');
     Memo1.Lines.Add(Daten);
    end;

  // Zuletzt sollte die Verbindung geschlossen werden
  TCPClient.Disconnect;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // Eine evlt. noch bestehende Verbindung
  // wird getrennt
  TCPClient.Disconnect;

  // Die Angaben der Edit-Felder werden in die
  // Komponente geschrieben
  TCPClient.Host := edit1.text;
  TCPClient.Port := spinedit1.value;
  try
    // Ein Verbindungsversuch wird unternommen
    TCPClient.Connect;
  except
    // Es trat ein Fehler auf - keine Verbindung.
    on E:EIdSocketError do
      Memo1.Lines.Add('Keine Verbindung: '+E.Message);
    on E:Exception do
      Memo1.Lines.Add('Sonstiger Fehler: '+E.Message);
  end;

  // Eine Leerzeile soll schon im Memo folgen...
  Memo1.Lines.Add('');  
end;

procedure TForm1.Label3Click(Sender: TObject);
begin
  Showmessage('Dieses Programm wurde von Ulf Schaper geschrieben, bei Fragen bitte an UlfSchaper@gmx.de wenden. '#13#10#13#10'Ich verwende die Indy-Komponenten. Sie finden die Lizenzbedingungen auf www.nevrona.com/indy.');
end;

end.
